-- 2021-04-22 License CC0 (Creative Commons license) (c) darkfrei

--function cos (a)
--	return -math.cos(a)
--end
sin = math.sin
cos = math.cos

function love.load()
	love.window.setMode(1920, 1080, {resizable=false, borderless=true})
	love.graphics.setLineWidth( 4 )

	
	g = 9.81*10*10
	
	l1, m1, O1, w1 = 250, 10, -1*math.pi, 0
	l2, m2, O2, w2 = 260, 10, -0.9*math.pi, 0
	
	buffer = 0
	
	canvas = love.graphics.newCanvas(love.graphics.getDimensions())
	
	pause = true
	
--	om, wm, am = 0,0,0
--	om, wm, am = 14.919457639821, 12.933669961054, 61.831790757311

	om, wm, am = 16.553214368359, 14.957066856535, 80.855604791708

end


function love.update(dt2)
	if pause then return end
	
	buffer = buffer + dt2
	local dt = 1/300000
	
	local points = {}
	love.graphics.setCanvas(canvas)
	while buffer > dt do
		buffer = buffer - dt
		
--		local alfa1=(g*(2*m1+m2)*sin(O1)+g*m2*sin(O1-2*O2)-2*m2*sin(O1-O2)*(w2*w2*l2+w1*w1*l1*cos(O1-O2)))/(l1*(2*m1+m2-m2*cos(2*O1-2*O2)))
--		local alfa2=(2*sin(O1-O2 ))*(w1*w1*l1*(m1+m2)+g*(m1+m2)*cos(O1)+w2*w2*l2*m2*cos(O1-O2))/l2/(2*m1 +m2 -m2 *cos(2*O1-2*O2))
		
		local alfa1=( -g*(2*m1 +m2 )*sin(O1 )-g*m2 *sin(O1 -2*O2 )-2*m2 *sin(O1 -O2 )*(w2 *w2 *l2 +w1 *w1 *l1 *cos(O1 -O2 )) )/( l1 *(2*m1 +m2 -m2 *cos(2*O1 -2*O2 )) )
		local alfa2=( 2*sin(O1 -O2 ) )*( w1 *w1 *l1 *(m1 +m2 ) + g*(m1 +m2 )*cos(O1 ) + w2 *w2 *l2 *m2 *cos(O1 -O2 ) )/l2 /( 2*m1 +m2 -m2 *cos(2*O1 -2*O2 ) )


		
		w1=w1+dt*alfa1
		w2=w2+dt*alfa2
		
		O1=O1+dt*w1
		O2=O2+dt*w2
		
		x0 = love.graphics.getWidth()/2
		y0 = love.graphics.getHeight()/2
		
		x1 = x0+l1*sin(O1)
		y1 = y0+l1*cos(O1)
		
		x2 = x1+l2*sin(O2)
		y2 = y1+l2*cos(O2)
		
		local o, w, a = math.abs(O2-O1), math.abs(w2-w1), math.abs(alfa2-alfa1)
--		if (o) > om then om = (o) end
--		if (w) > wm then wm = (w) end
--		if (a) > am then am = (a) end

		love.graphics.setColor(o/om, 0.5+0.5*(w/wm), a/am)
--		love.graphics.setColor(1,1,1)
		love.graphics.points(x2, y2)
	end
	
		
	love.graphics.setCanvas()
end


function love.draw()
	if pause then
		love.graphics.print('press space')
	end
	love.graphics.setColor(1,1,1)
	if x2 then
		love.graphics.line(x0, y0, x1, y1)
		love.graphics.line(x1, y1, x2, y2)
	end
	love.graphics.draw(canvas)
end

function love.keypressed(key, scancode, isrepeat)
   if key == "space" then
	   pause = not pause
   elseif key == "escape" then
		print(om ..', ' .. wm .. ', ' .. am)
		love.event.quit()
   end
end